#define PI 3.141592653589793

attribute float angle;
attribute vec3 hackNormal;

uniform float worldScale;

uniform float maxBokehSize;
uniform float dofCurve;

uniform float elapsedTime;
uniform vec3 center;

uniform float pixelRatio;
uniform float aspectRatio;
uniform float aux;
uniform float aux2;

uniform float lightCurve;
uniform float minSize;
uniform float maxSize;

uniform vec3 highColor;
uniform vec3 lowColor;
uniform vec3 distColor;

varying vec3 vColor;
varying vec3 vN;
varying float bokehPower;

varying mat3 vRot;

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main() {

	float spinSpeed = 1.0;
	float minVariationSize = 3.4;
	float variagation = 10.0;

	// float baseSize = 150.0 * (1.0 - length(position));
	float baseSize = mix(maxSize, minSize, length(position));
	float varianceCurve = 18.0;
	float sizeVariance = (variagation*pow(rand(position.xz), varianceCurve)+minVariationSize);

	// vColor = normal;
	// vColor = hackNormal;
	vec4 mvPosition = modelViewMatrix * vec4(position, 1.0);
	gl_PointSize = baseSize / length(mvPosition.xyz) * sizeVariance * aspectRatio;
	gl_PointSize *= 100000.0;

	float theta = rand(position.xy) * 2.0 * PI + angle * (rand(position.yz) - 0.5) * 2.0 * spinSpeed;
	// float theta = angle;
	// float theta = aux * 2.0 * PI;
	float c = cos(theta);
    float s = sin(theta);
	vRot = mat3(c, -s, 0.0, s, c, 0.0, (1.0-c-s)*0.5, (1.0+s-c)*0.5, 1.0);

	
	gl_Position = projectionMatrix * mvPosition;

	float lightPower = pow((dot(normalize(position), normalize(hackNormal)) + 1.0) * 0.5, lightCurve);
	vColor = mix(highColor, lowColor, lightPower);
	vColor = mix(vColor, distColor, length(position));

	// vec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );
	// gl_PointSize = 500.0 / length(mvPosition.xyz);
	// // gl_PointSize = 1.0;
	// gl_Position = projectionMatrix * mvPosition;
}
